/*
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.rs.testbackward;

import com.android.rs.unittest.*;

import java.util.ArrayList;

/**
 * This class is auto-generated by frameworks/rs/tests/java_api/RSUnitTests/RSUnitTests.py.
 * To change unit tests version, please run the Python script above.
 */
public class RSTests {
    public static Iterable<Class<? extends UnitTest>> getTestClassesForCurrentAPIVersion() {
        int thisApiVersion = android.os.Build.VERSION.SDK_INT;

        ArrayList<Class<? extends UnitTest>> validClasses = new ArrayList<>();

        if (thisApiVersion >= 19) {
            validClasses.add(UT_alloc.class);
            validClasses.add(UT_array_alloc.class);
            validClasses.add(UT_array_init.class);
            validClasses.add(UT_atomic.class);
            validClasses.add(UT_bitfield.class);
            validClasses.add(UT_bug_char.class);
            validClasses.add(UT_check_dims.class);
            validClasses.add(UT_clamp.class);
            validClasses.add(UT_clamp_relaxed.class);
            validClasses.add(UT_constant.class);
            validClasses.add(UT_convert.class);
            validClasses.add(UT_convert_relaxed.class);
            validClasses.add(UT_copy_test.class);
            validClasses.add(UT_element.class);
            validClasses.add(UT_foreach.class);
            validClasses.add(UT_foreach_bounds.class);
            validClasses.add(UT_fp_mad.class);
            validClasses.add(UT_instance.class);
            validClasses.add(UT_int4.class);
            validClasses.add(UT_kernel.class);
            validClasses.add(UT_kernel_struct.class);
            validClasses.add(UT_math.class);
            validClasses.add(UT_min.class);
            validClasses.add(UT_noroot.class);
            validClasses.add(UT_primitives.class);
            validClasses.add(UT_refcount.class);
            validClasses.add(UT_reflection3264.class);
            validClasses.add(UT_rsdebug.class);
            validClasses.add(UT_rstime.class);
            validClasses.add(UT_rstypes.class);
            validClasses.add(UT_sampler.class);
            validClasses.add(UT_static_globals.class);
            validClasses.add(UT_struct.class);
            validClasses.add(UT_unsigned.class);
            validClasses.add(UT_vector.class);
        }

        if (thisApiVersion >= 21) {
            validClasses.add(UT_foreach_multi.class);
            validClasses.add(UT_math_agree.class);
            validClasses.add(UT_math_conformance.class);
        }

        if (thisApiVersion >= 23) {
            validClasses.add(UT_alloc_copy.class);
            validClasses.add(UT_alloc_copyPadded.class);
            validClasses.add(UT_ctxt_default.class);
            validClasses.add(UT_kernel2d.class);
            validClasses.add(UT_kernel2d_oldstyle.class);
            validClasses.add(UT_kernel3d.class);
            validClasses.add(UT_rsdebug_23.class);
            validClasses.add(UT_script_group2_gatherscatter.class);
            validClasses.add(UT_script_group2_nochain.class);
            validClasses.add(UT_script_group2_pointwise.class);
        }

        if (thisApiVersion >= 24) {
            validClasses.add(UT_fp16.class);
            validClasses.add(UT_fp16_globals.class);
            validClasses.add(UT_math_24.class);
            validClasses.add(UT_math_fp16.class);
            validClasses.add(UT_reduce.class);
            validClasses.add(UT_reduce_backward.class);
            validClasses.add(UT_rsdebug_24.class);
            validClasses.add(UT_script_group2_float.class);
            validClasses.add(UT_single_source_alloc.class);
            validClasses.add(UT_single_source_ref_count.class);
            validClasses.add(UT_single_source_script.class);
            validClasses.add(UT_small_struct.class);
            validClasses.add(UT_small_struct_2.class);
        }

        if (thisApiVersion >= 26) {
            validClasses.add(UT_blur_validation.class);
            validClasses.add(UT_struct_field.class);
            validClasses.add(UT_struct_field_simple.class);
        }

        return validClasses;
    }
}
