/*
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.rs.testbackward19;

import com.android.rs.unittest.*;

import java.util.ArrayList;

/**
 * This class is auto-generated by frameworks/rs/tests/java_api/RSUnitTests/RSUnitTests.py.
 * To change unit tests version, please run the Python script above.
 */
public class RSTests {
    public static Iterable<Class<? extends UnitTest>> getTestClassesForCurrentAPIVersion() {
        int thisApiVersion = android.os.Build.VERSION.SDK_INT;

        ArrayList<Class<? extends UnitTest>> validClasses = new ArrayList<>();

        if (thisApiVersion >= 19) {
            validClasses.add(UT_alloc.class);
            validClasses.add(UT_array_alloc.class);
            validClasses.add(UT_array_init.class);
            validClasses.add(UT_atomic.class);
            validClasses.add(UT_bitfield.class);
            validClasses.add(UT_bug_char.class);
            validClasses.add(UT_check_dims.class);
            validClasses.add(UT_clamp.class);
            validClasses.add(UT_clamp_relaxed.class);
            validClasses.add(UT_constant.class);
            validClasses.add(UT_convert.class);
            validClasses.add(UT_convert_relaxed.class);
            validClasses.add(UT_copy_test.class);
            validClasses.add(UT_element.class);
            validClasses.add(UT_foreach.class);
            validClasses.add(UT_foreach_bounds.class);
            validClasses.add(UT_fp_mad.class);
            validClasses.add(UT_instance.class);
            validClasses.add(UT_int4.class);
            validClasses.add(UT_kernel.class);
            validClasses.add(UT_kernel_struct.class);
            validClasses.add(UT_math.class);
            validClasses.add(UT_min.class);
            validClasses.add(UT_noroot.class);
            validClasses.add(UT_primitives.class);
            validClasses.add(UT_refcount.class);
            validClasses.add(UT_reflection3264.class);
            validClasses.add(UT_rsdebug.class);
            validClasses.add(UT_rstime.class);
            validClasses.add(UT_rstypes.class);
            validClasses.add(UT_sampler.class);
            validClasses.add(UT_static_globals.class);
            validClasses.add(UT_struct.class);
            validClasses.add(UT_unsigned.class);
            validClasses.add(UT_vector.class);
        }

        return validClasses;
    }
}
